# -*- coke -*-

long	= &`long?   .
name	= &`symbol? .

arity	= .*:x					->`(list-length x)

args	= expr:e args:a				-> (::a ::e save)
	| expr:e				-> (::e save)
	| 					-> ()

params	= ( name:h params
	  | name:h
	  )					->`(arg-name h)
	|

body	= expr:e body:b				-> (::e ::b)
	| expr:e				-> :e

expr	= '( 'define name:n expr:e )		-> (long :n ::e store-var :n)
	| '( 'lambda '(params) expr*:b )	-> (enter :::b leave) :l ->`(save-lambda l):n -> (load-label :n)
	| '( 'if     expr:t expr:x expr:y )	->`(new-label):a ->`(new-label):b -> (::t branch-false :a ::x branch :b label :a ::y label :b)
	| '( '<      expr:x expr:y )		-> (::y save ::x less)
	| '( '+      expr:x expr:y )		-> (::y save ::x add)
	| '( '-      expr:x expr:y )		-> (::y save ::x sub)
	| '( &. expr:f &arity:n args:a )	-> (::a ::f call :n)
        |    long:x				-> (load-long :x)
        |    name:x &`(is-arg x):n		-> (load-arg  :n)
        |    name:x				-> (load-var  :x)
	|    .:x				->`(error "unrecognised expression" x)

start = expr
